cseg	segment
	.286
	assume	cs:cseg,ds:cseg
	org	80h
command_line_length	label	byte
	org	81h
command_line	label	byte
	org	100h
start:	jmp	main

Read_options	proc	near
	mov	cl,option_number
	xor	ch,ch

to1:	push	cx
	xor	di,di
	xor	dx,dx
	xor	ah,ah
	mov	bl,option_number
	xor	bh,bh
	sub	bx,cx
	shl	bx,1
	mov	bx,[option_addresses+bx]
	lea	si,command_line
	mov	cl,command_line_length
	inc	cl
	xor	ch,ch

to11:	lodsb
	cmp	byte ptr [bx+di],'$'
	je	next_number
	cmp	al,[bx+di]
	je	to2
	cmp	byte ptr [bx+di],'A'
	jb	to21
	cmp	byte ptr [bx+di],'Z'
	ja	to21
	sub	al,'a'-'A'
	cmp	al,[bx+di]
	je	to2
to21:	xor	di,di
	jmp	to3
to2:	inc	di
	jmp	to3

next_number:
	cmp	al,'0'
	jb	to4
	cmp	al,'9'
	ja	to4

	push	ax
	shl	dx,1
	mov	ax,dx
	shl	dx,1
	shl	dx,1
	add	dx,ax
	pop	ax

	sub	al,'0'
	add	dx,ax
	jmp	to3

to4:	or	dx,dx
	jnz	to5
	inc	dx
	
to5:	mov	[bx+di+1],dx
	mov	cx,1
to3:	loop	to11

	pop	cx
	loop	to1
	ret
Read_options	endp

message	proc	near
;	this procedure print error-message with number AL
	pusha

	lea	si,messages_addresses
	xor	ah,ah
	shl	ax,1
	add	si,ax
	mov	si,[si]
	lodsb
	mov	bl,al		; p
	mov	ah,9
	xor	bh,bh
	
mm1:	lodsb
	cmp	al,'$'
	jz	mm2
	cmp	al,10
	je	mm3
	cmp	al,13
	jne	mm4
mm3:	mov	ah,0eh
	int	10h
	jmp	mm1

mm4:	mov	ah,9
	mov	cx,1
	int	10h
	mov	ah,3
	int	10h
	inc	dl
	mov	ah,2
	int	10h
	jmp	mm1

mm2:	popa
	ret
message	endp

File_open	proc	near
	mov	cl,command_line_length
	xor	ch,ch
	lea	si,command_line
	xor	ah,ah
	
fo1:	lodsb
	or	ah,ah
	jnz	fo2
	cmp	al,' '
	je	fo3
	inc	ah
	mov	dx,si
	dec	dx
	jmp	fo3

fo2:	cmp	al,' '
	je	fo4
	cmp	al,'/'
	jne	fo3
fo4:	dec	si
	mov	cx,1
fo3:	loop	fo1

	mov	byte ptr [si],0
	mov	ax,3d00h
	int	21h
	jnc	fo5

	mov	al,2
	call	message
	int	20h

fo5:	mov	fm,ax
	ret
File_open	endp

dump_to_file	proc	near
	push	cx
	lea	dx,fspec
	mov	ah,3ch
	xor	cx,cx
	int	21h
	mov	fm,ax
	
	lea	dx,buffer
	mov	ah,40h
	mov	bx,word ptr Sectors_number
	mov	cl,9
	shl	bx,cl
	mov	cx,bx
	mov	bx,fm
	int	21h
	
	mov	ah,3eh
	int	21h
	pop	cx
	ret
dump_to_file	endp

dump_to_file1	proc	near
	push	cx
	lea	dx,fspec1
	mov	ah,3ch
	xor	cx,cx
	int	21h
	mov	fm,ax
	
	lea	dx,buffer
	mov	ah,40h
	mov	bx,word ptr Sectors_number
	mov	cl,9
	shl	bx,cl
	mov	cx,bx
	mov	bx,fm
	int	21h
	
	mov	ah,3eh
	int	21h
	pop	cx
	ret
dump_to_file1	endp

read_file	proc	near
	lea	dx,fspec
	mov	ax,3d00h
	int	21h
	jnc	rf1
	mov	al,3
	call	message
	jmp	exit
rf1:	mov	bx,ax
	mov	ah,3fh
	mov	cx,512
	lea	dx,buffer
	int	21h
	jnc	rf2
	jmp	exit
rf2:	mov	ah,3eh
	int	21h
	ret
read_file	endp

if 0
read_sector	proc	near
	pusha
;	mov	al,driver
;	mov	dx,word ptr Sector
;	mov	cx,word ptr Sectors_number
;	mov	bx,Sector_address
;	int	25h
;	pop	ax
;	popa
;	ret

	mov	max_time,1
	
again:	cmp	max_time,0
	je	rs_ex
	
	dec	max_time
	mov	ax,word ptr Sector
	mov	dx,word ptr Sector[2]
	div	sectors_per_cylinder
	mov	ch,al
	mov	bl,ah
	mov	cl,6
	shl	bl,cl	; 訥 ࠧ 樫
	mov	ax,dx
	div	byte ptr sectors_per_track
	mov	dh,al
	inc	ah
	mov	cl,ah
	or	cl,bl
	mov	ah,2
	mov	dl,driver
	mov	bx,Sector_address
	mov	al,Sectors_number

	int	13h
	jmp	again
	
rs_ex:	popa
	ret
read_sector	endp
	
write_sector	proc	near
	pusha
	mov	ax,word ptr Sector
	mov	dx,word ptr Sector[2]
	div	sectors_per_cylinder
	mov	ch,al
	mov	bl,ah
	mov	cl,6
	shl	bl,cl	; 訥 ࠧ 樫
	mov	ax,dx
	div	byte ptr sectors_per_track
	mov	dh,al
	inc	ah
	mov	cl,ah
	or	cl,bl
	mov	ah,3
	mov	dl,driver
	mov	bx,Sector_address
	mov	al,Sectors_number
	int	13h
	popa
	ret
write_sector	endp
	
read_parameters	proc	near
	mov	ah,2
	mov	dl,DriveNumber
	mov	al,1	; sectors_number
	mov	dh,1	; head
	mov	ch,0	; cylinder
	mov	cl,1	; sector
	lea	bx,buffer
	int	13h

	lea	si,buffer+3
	lea	di,DISC_PARAMETERS
	mov	cx,3bh
	rep	movsb	; ७ ࠬ஢ ⥬
	mov	al,byte ptr heads_count
	mov	ah,byte ptr sectors_per_track
	mul	ah
	mov	sectors_per_cylinder,ax

	ret
read_parameters	endp
endif

main:	mov	al,0
	call	message
	cmp	command_line_length,0
	je	help
	call	Read_options
	cmp	Help_Flag,0
	jnz	help
	cmp	Help1_Flag,0
	jz	m1
help:	mov	al,1
	call	message
	jmp	exit
m1:	cmp	word ptr Sectors_number,100
	jle	go
	mov	word ptr Sectors_number,100

go:	cmp	Slave_Flag,0
	je	Master
	inc	DriveNumber
Master:	cmp	Save_Flag,0
	jne	Save
	cmp	Restore_Flag,0
	jne	Restore
Save:
;	call	read_parameters
;	call	read_sector
	mov	ah,2
	mov	dl,DriveNumber
	mov	al,1	; sectors_number
	mov	dh,0	; head
	mov	ch,0	; cylinder
	mov	cl,1	; sector
	lea	bx,buffer
	int	13h
	call	dump_to_file
	jmp	exit

Restore:
;	call	write_sector
	mov	ah,2
	mov	dl,DriveNumber
	mov	al,1	; sectors_number
	mov	dh,0	; head
	mov	ch,0	; cylinder
	mov	cl,1	; sector
	lea	bx,buffer
	int	13h
	call	dump_to_file1

	call	read_file
	mov	ah,3
	mov	dl,DriveNumber
	mov	al,1	; sectors_number
	mov	dh,0	; head
	mov	ch,0	; cylinder
	mov	cl,1	; sector
	lea	bx,buffer
	int	13h

exit:	int	20h

;---------------------------------- D A T A -----------------------------------
DISC_PARAMETERS	label	byte
DOS_Name	db	8 dup(?)
sector_size	dw	?	; ࠧ ᥪ  
sectors_per_claster	db	? ; ᥪ஢  
reserve_sectors	dw	?	; । FAT
FAT_count	db	?	; ᫮ FAT
Root_size	dw	?	; . ᫮ 32-⮢ ⮢ 
total_sectors	dw	?	; ᥪ஢ ᥣ   ࠧ DOS
media		db	?	; ਯ ⥫(1-  FAT)
FAT_size	dw	?	; ᫮ ᥪ஢  1- FAT
sectors_per_track	dw	? ; ᫮ ᥪ஢  ஦
heads_count	dw	?	; ᫮ 
hidden_sectors_count	dd	? ; ᫮ ⠭ ᥪ஢ ( 1- ࠧ)
total_sectors_plus	dd	? ; ᫮ ᥪ஢, ᫨ ࠧ ᪠  32
driver		db	?	;  ᪠
res		db	?	;
extBPB		db	?	; ')'
serial_number	dd	?	; ਩  ᪠
volume_label	db	11 dup(?) ; ⪠ ᪠
system_identifier	db	8 dup(?)
sectors_per_cylinder	dw	?

Sector	dd	0
Sector_address	dw	buffer
Sectors_number	db	1,0
DriveNumber	db	80h

messages_addresses	dw	head_msg,hlp_msg,err_msg
head_msg	db 0bh,'The MBR-Saver, Ver. 1.01, Copyright (C) '
		db 'by Eugene A. Kalinin, Kirov, 19.05.2000',10,13,'$'
hlp_msg	db 0dh,'ଠ ᪠ :    MBRSaver [/H] [/?] [/S] [/R] [/2]',10,13
	db '樨 : /?,/H -   ଠ樨  ࠭;',13,10
	db '        /S    - ࠭ MBR-ᥪ  䠩 MBR.DAT;',13,10
	db '        /R    - ⠭ MBR-ᥪ  䠩 MBR.DAT',13,10
	db '                (ᠬ ᥪ ࠭ । ⨬  䠩 MBR.PRV);',13,10
	db '        /2    - 믮 ࠭/⠭  2- (Slave) ',13,10
	db '                (ॣ ᨬ   祭).'
	db 10,13,'$'
err_msg	db 8fh,'ࠢ쭮  䠩 !',10,13,'$'

option_number	db	5
option_addresses	dw	optH,opt?,optS,optR,opt2
optH	db	'/H$'
Help_Flag	dw	0
opt?	db	'/?$'
Help1_Flag	dw	0
optS	db	'/S$'
Save_Flag	dw	0
optR	db	'/R$'
Restore_Flag	dw	0
opt2	db	'/2$'
Slave_Flag	dw	0

fm	dw	?
fspec	db	'mbr.dat',0
fspec1	db	'mbr.prv',0
max_time	dw	?
buffer	db	512 dup(?)
cseg	ends
	end	start
